import { ReactNativeToggleElementProps, ThumbButton, ThumbButtonConfig, ThumbChildrenProps, ToogleTrackBar, TrackBar, TrackBarConfig } from "./types";
export declare const COLOR_DEFAULT: {
    trackActiveBg: string;
    trackInActiveBg: string;
    textActive: string;
    textInActive: string;
    thumbActive: string;
    thumbInActive: string;
    disable: string;
    borderColor: string;
};
export declare const SIZE_DEFAULT: {
    trackBarHeight: number;
    trackBarRadius: number;
    trackBarWidth: number;
    thumbBtnHeight: number;
    thumbBtnRadius: number;
    thumbBtnWidth: number;
    borderWidth: number;
};
export declare const defaultTrackBar: TrackBarConfig;
export declare const defaultThumbButton: ThumbButtonConfig;
export declare const DefaultThumbChildrenProps: ThumbChildrenProps;
export declare const DefaultReactNativeToggleElementProps: ReactNativeToggleElementProps;
export declare const ToggleStyles: {
    container: {
        flexDirection: "row";
        alignItems: "center";
    };
    thumbPosition: {
        position: "absolute";
        justifyContent: "center";
        alignItems: "center";
    };
    thumbLeft: {
        left: number;
    };
    thumbRight: {
        right: number;
    };
    thumbAnimatedPosition: {
        position: "absolute";
    };
};
export declare const ToogleTrackBarStyles: Record<"trackBar", (trackBar: TrackBar) => ToogleTrackBar>;
export declare const ToggleThumbButtonStyles: {
    thumbButton: (thumbButton: ThumbButton, trackBarBorderWidth?: number) => {
        width: number;
        height: number;
        borderRadius: number;
    };
};
